//+------------------------------------------------------------------+
//|                                                       Diablo.mq4 |
//|                                                             Cmu4 |
//|                                                          http:// |
//+------------------------------------------------------------------+
#property copyright "Cmu4"
#property link      "http://"
#property show_inputs

extern int    Step=500,
              Spread=20,
              Levels=5, 
              Profit=100;

extern double Up=0,
              Vol=0.1;

int TotalOrders,i, Shet;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
Up=Ask;
for (i=0; i<=TotalOrders; i++){
  if (OrderSelect(0,SELECT_BY_POS)==true){
    if (OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid,5,Red);
    if (OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,5,Red);
    if (OrderType()==OP_SELLSTOP) OrderDelete(OrderTicket(),Green);
    if (OrderType()==OP_BUYSTOP) OrderDelete(OrderTicket(),Green);
    if (OrderType()==OP_SELLLIMIT) OrderDelete(OrderTicket(),Green);
    if (OrderType()==OP_BUYLIMIT) OrderDelete(OrderTicket(),Green);
         }}

for(int i=0;i<(Levels);i++)
{OrderSend(Symbol(),OP_BUYSTOP,Vol,Up+(i*Step+Spread)*Point,0,Up+(i-1)*Step*Point,0,0,0);
 OrderSend(Symbol(),OP_SELLSTOP,Vol,Up-(i+1)*Step*Point,0,Up-(i*Step-Spread)*Point,0,0,0);
 OrderSend(Symbol(),OP_SELLLIMIT,Vol,Up+i*Step*Point,0,Up+((i+1)*Step+Spread)*Point,Up-(Step*(i+1)-Spread)*Point,0,0);
 OrderSend(Symbol(),OP_BUYLIMIT,Vol,Up-((i+1)*Step-Spread)*Point,0,Up-(i+2)*Step*Point,Up+i*Step*Point,0,0);
 }

return(0);}

int deinit() {return(0);}

int start()
{Up=Ask;
 TotalOrders=OrdersTotal();
 
 if (TotalOrders>0 && Profit()>Profit)
 {for (i=0; i<=TotalOrders; i++){
  if (OrderSelect(0,SELECT_BY_POS)==true){
    if (OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid,5,Red);
    if (OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,5,Red);
    if (OrderType()==OP_SELLSTOP) OrderDelete(OrderTicket(),Green);
    if (OrderType()==OP_BUYSTOP) OrderDelete(OrderTicket(),Green);
    if (OrderType()==OP_SELLLIMIT) OrderDelete(OrderTicket(),Green);
    if (OrderType()==OP_BUYLIMIT) OrderDelete(OrderTicket(),Green);
         }}

for(int i=0;i<(Levels);i++)
{OrderSend(Symbol(),OP_BUYSTOP,Vol,Up+(i*Step+Spread)*Point,0,Up+(i-1)*Step*Point,0,0,0);
 OrderSend(Symbol(),OP_SELLSTOP,Vol,Up-(i+1)*Step*Point,0,Up-(i*Step-Spread)*Point,0,0,0);
 OrderSend(Symbol(),OP_SELLLIMIT,Vol,Up+i*Step*Point,0,Up+((i+1)*Step+Spread)*Point,Up-(Step*(i+1)-Spread)*Point,0,0);
 OrderSend(Symbol(),OP_BUYLIMIT,Vol,Up-((i+1)*Step-Spread)*Point,0,Up-(i+2)*Step*Point,Up+i*Step*Point,0,0);
 }}
 
return(0);
}

//+------------------------------------------------------------------+
double Profit(string sy="", int op=-1, int mn=-1) {
  double p=0;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            p+=OrderProfit()+OrderCommission()+OrderSwap();
          }
        }
      }
    }
  }
  return(p);
}  